package com.zd.bottle.service;

import com.zd.bottle.domain.UseRecord;
import com.baomidou.mybatisplus.extension.service.IService;
import com.zd.bottle.dto.UseRecordDto;
import com.zd.bottle.vo.AirAmount;
import com.zd.bottle.vo.UseRecordVo;
import com.zd.bottle.vo.WebUseRecordVo;

import java.util.List;

/**
 * <p>
 * 使用记录表 服务类
 * </p>
 *
 * @author hanson
 * @since 2022-09-08
 */
public interface UseRecordService extends IService<UseRecord> {

    /**
     * 集合转视图类接口
     * @param records 源数据
     * @return List
     */
    List<UseRecordVo> getListVo(List<UseRecord> records);

    /**
     * 获取数据
     * @param useRecord 查询参数
     * @return List
     */
    List<UseRecord> getList(UseRecord useRecord);

    /**
     * 信息统计查询使用记录列表
     * @param storageId 库存主ID
     * @return 集合对象
     */
    List<UseRecordVo> getBottleInfoByStorageId(Long storageId);
    /**
     * 管理端端获取使用记录详细信息
     * @param id 记录ID
     * @return 组合数据
     */
    WebUseRecordVo getBottleInfo(Long id);

    /**
     * 管理端端获取使用记录详细信息
     * @param storageId 气瓶ID
     * @return 组合数据
     */
    WebUseRecordVo getBottleRecord(Long storageId);

    /**
     * 出入库信息统计
     * @param airName 气体名称
     * @return 数据集合
     */
    List<AirAmount> calcRepertory(String airName);

    /**
     * 用气量信息统计
     * @param airName 气体名称
     * @return 数据集合
     */
    List<AirAmount> calcAmount(String airName);

    /**
     * 新增使用记录
     *
     * @param recordDto 使用记录
     * @return 结果
     */
    Integer add(UseRecordDto recordDto);
    /**
     * 修改使用记录
     *
     * @param useRecord 使用记录
     * @return 结果
     */
    Integer updateUseRecord(UseRecord useRecord);

    /**
     * 当前登录人的气瓶使用记录
     * @param useRecord 参数
     * @return List
     */
    List<UseRecord> getByUserId(UseRecord useRecord);

    /**
     * 根据气瓶ID查询
     * @param storageId 气瓶主键
     * @return List
     */
    List<UseRecord> getByStorageId(Long storageId);

    /***
     * 查询气瓶的使用记录
     * @param storageId 入库ID
     * @return List<UseRecordVo>
     */
    List<UseRecordVo> getListUseRecord(Long storageId);

    /**
     * 用气量信息统计
     * @param airName 气体名称
     * @return 数据集合
     */
    List<AirAmount> calcApply(String airName);

    /***
     * 查询气瓶是否归还
     * @param storageId
     * @return
     */
    List<UseRecord> getListNotReturn(Long storageId);
}
